package io.scanbot.sdk.reactnative

import com.facebook.react.bridge.Promise
import io.scanbot.sdk.reactnative.extensions.toWritableArray
import io.scanbot.sdk.reactnative.extensions.toWritableMap
import io.scanbot.sdk_wrapper.interfaces.SBResultDelegate
import org.json.JSONArray
import org.json.JSONObject

class ScanbotSDKPluginResultDelegate(private val promise: Promise) : SBResultDelegate {

    override fun onResolvePromise(result: Any?) {
        when (result) {
            is JSONArray -> promise.resolve(result.toWritableArray())

            is JSONObject -> promise.resolve(result.toWritableMap())

            else -> promise.resolve(result)
        }
    }

    override fun onRejectPromise(error: String) {
        promise.reject("", Exception(error))
    }
}
