package io.scanbot.sdk.reactnative.components.document_scanner_view

import android.util.Base64
import com.facebook.react.bridge.Arguments
import com.facebook.react.bridge.WritableMap
import io.scanbot.sdk.document.DocumentScannerFrameHandler
import io.scanbot.sdk.reactnative.models.BaseEvent

class DocumentScannerResultEvent(private val image: ByteArray) : BaseEvent {

    companion object {
        const val NAME = "documentScannerResult"
    }

    override val eventName = NAME

    override fun parseData(): WritableMap {
        val encoded: String = Base64.encodeToString(image, Base64.DEFAULT)

        return Arguments.createMap().apply {
            putString("result", encoded)
        }
    }
}

class DocumentScannerDetectionResultEvent(private val frameResult: DocumentScannerFrameHandler.DetectedFrame) :
    BaseEvent {

    companion object {
        const val NAME = "detectionResult"
    }

    override val eventName = NAME

    override fun parseData(): WritableMap {
        return Arguments.createMap().apply {
            putString("result", frameResult.detectionStatus.toJson())
        }
    }
}