
#ifndef RNScanbotBarcodeScannerViewControllerWrapper_h
#define RNScanbotBarcodeScannerViewControllerWrapper_h
#import <AVFoundation/AVFoundation.h>
#import <ScanbotSDK/ScanbotSDK-Swift.h>
#import <ScanbotSDKNativeWrapper/ScanbotSDKNativeWrapper-Swift.h>

@interface RNScanbotBarcodeScannerViewControllerWrapper : NSObject

+ (SBSDKBarcodeScannerViewController * _Nonnull) initController;

+ (void) setFlashEnabled:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                   value:(BOOL)value;

+ (void) setFinderEnabled:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                    value:(BOOL)value;

+ (void) setFinderStrokeWidth:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                        value:(int)value;

+ (void) setFinderStrokeColor:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                        value:(UIColor * _Nullable)value;

+ (void) setFinderOverlayColor:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                         value:(UIColor * _Nullable)value;

+ (void) setFinderInset:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                    top:(float)top
                   left:(float)left
                 bottom:(float)bottom
                  right:(float)right;

+ (void) setFinderRequiredAspectRatios:(SBSDKBaseScannerViewFinderConfiguration* _Nonnull)config
                                 width:(double)width
                                height:(double)height;

+ (void) setCameraZoomFactor:(SBSDKBaseScannerZoomConfiguration* _Nonnull)config
                       value:(float)value;

+ (void) setCameraZoomRange:(SBSDKBaseScannerZoomConfiguration* _Nonnull)config
                    minZoom:(float)minZoom
                    maxZoom:(float)maxZoom;

+ (void) setCameraDevice:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                   value:(NSString * _Nullable)value;

+ (void) setMinFocusDistanceLock:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                           value:(BOOL)value;

+ (void) setOverlayEnabled:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                     value:(BOOL)value;

+ (void) setOverlayAutomaticSelectionEnabled:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                                       value:(BOOL)value;

+ (void) setOverlayPolygonColor:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                          value:(UIColor * _Nullable)value;

+ (void) setOverlayStrokeColor:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                         value:(UIColor * _Nullable)value;

+ (void) setOverlayTextColor:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                       value:(UIColor * _Nullable)value;

+ (void) setOverlayTextContainerColor:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                                value:(UIColor * _Nullable)value;

+ (void) setOverlayTextFormat:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                        value:(NSString * _Nullable)value;

+ (void) setConfigExtractedDocumentFormats:(SBSDKBarcodeScannerConfiguration* _Nonnull)config
                                   formats:(NSArray<NSString *> * _Nullable)formats;

+ (void) setConfigOnlyAcceptDocuments:(SBSDKBarcodeScannerConfiguration* _Nonnull)config
                                value:(BOOL)value;

+ (void) setConfigReturnBarcodeImage:(SBSDKBarcodeScannerConfiguration* _Nonnull)config
                               value:(BOOL)value;

+ (void) setHardwareButtonsEnabled:(SBSDKBarcodeScannerViewController* _Nonnull)controller
                             value:(BOOL)value;

+ (void) setConfigEngineMode:(SBSDKBarcodeScannerConfiguration* _Nonnull)config
                       value:(NSString * _Nullable)value;

+ (NSString * _Nullable) jsonFromResultOrNil:(NSArray<SBSDKBarcodeItem *> * _Nonnull)codes;

+ (void) freezeCamera:(SBSDKBarcodeScannerViewController* _Nonnull)controller;

+ (void) unfreezeCamera:(SBSDKBarcodeScannerViewController* _Nonnull)controller;

+ (void) addBarcodeItemOverlayViewInitialBinderInDictionary:(NSMutableDictionary * _Nullable)dictionary
                                                loadingText:(NSString * _Nullable)loadingText
                                                   barcodes:(NSArray<SBSDKBarcodeItem *> * _Nonnull)barcodes;

+ (void) updateBarcodeItemOverlayViewBinderInDictionary:(NSMutableDictionary * _Nullable)dictionary
                                        barcodeItemUuid:(NSString * _Nonnull)barcodeItemUuid
                           barcodeItemOverlayViewConfigJson:(NSString * _Nonnull)barcodeItemOverlayViewConfigJson;

+ (SBSDKBarcodeTrackedViewPolygonStyle * _Nonnull) scannedBarcodePolygonStyle:(SBSDKBarcodeItem * _Nonnull)barcode
                                           barcodeItemOverlayViewBinding:(NSDictionary * _Nullable) barcodeItemOverlayViewBinding
                                                         controller:(SBSDKBarcodeScannerViewController* _Nonnull)controller;

+ (SBSDKBarcodeTrackedViewTextStyle * _Nonnull) scannedBarcodeOverlayViewTextStyle:(SBSDKBarcodeItem * _Nonnull)barcode
                                      barcodeItemOverlayViewBinding:(NSDictionary * _Nullable) barcodeItemOverlayViewBinding
                                                         controller:(SBSDKBarcodeScannerViewController* _Nonnull)controller;

+ (NSString * _Nonnull) scannedBarcodeOverlayViewText:(NSString * _Nonnull)barcodeItemUuid
                                       proposedString:(NSString * _Nonnull)proposedString
                        barcodeItemOverlayViewBinding:(NSDictionary * _Nullable)barcodeItemOverlayViewBinding;

@end

#endif /* RNScanbotBarcodeScannerViewHandler_h */
