import { CreditCardScanningStatus } from '../../credit_card/CreditCardTypes';
import { GenericDocument } from '../../documents/GenericDocument';
import { ToJsonConfiguration } from '../../utils/json/JsonSerializationTypes';
import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the credit card scanner RTU UI result.
*/
export declare class CreditCardScannerUiResult extends PartiallyConstructible {
    /**
      The status of the credit card recognition step.
      */
    readonly recognitionStatus: CreditCardScanningStatus;
    /**
      Generic document containing credit card data. Not present, if status is FAIL.
      */
    readonly creditCard: GenericDocument | null;
    /** @param source {@displayType `DeepPartial<CreditCardScannerUiResult>`} */
    constructor(source?: DeepPartial<CreditCardScannerUiResult>);
    serialize(config?: ToJsonConfiguration): Promise<DeepPartial<CreditCardScannerUiResult>>;
    private _released;
    release(): void;
    encodeImages(): Promise<void>;
}
//# sourceMappingURL=CreditCardScannerUIResult.d.ts.map