import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of visualization of the scanning progress - indeterminate progress.
*/
export declare class CreditCardScanningProgressConfiguration extends PartiallyConstructible {
    /**
      Enable or disable the scanning progress visualization.
      
      Default is true
      */
    enabled: boolean;
    /**
      The color of the scanning progress.
      
      Default is "#40A9FF"
      */
    progressColor: string;
    /**
      The duration of a single scanning progress cycle animation in milliseconds.
      
      Default is 1000
      */
    animationDuration: number;
    /** @param source {@displayType `DeepPartial<CreditCardScanningProgressConfiguration>`} */
    constructor(source?: DeepPartial<CreditCardScanningProgressConfiguration>);
}
//# sourceMappingURL=CreditCardScanningProgressConfiguration.d.ts.map