import { CameraScreenConfiguration } from '../../ui_v2/document/CameraScreenConfiguration';
import { CroppingScreenConfiguration } from '../../ui_v2/document/CroppingScreenConfiguration';
import { ReorderPagesScreenConfiguration } from '../../ui_v2/document/ReorderPagesScreenConfiguration';
import { ReviewScreenConfiguration } from '../../ui_v2/document/ReviewScreenConfiguration';
import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the document scanner sub-screens.
*/
export declare class DocumentScannerScreens extends PartiallyConstructible {
    /**
      Configuration of the screen for scanning the pages with the camera.
      */
    camera: CameraScreenConfiguration;
    /**
      Configuration of the screen for reviewing the scanned pages.
      */
    review: ReviewScreenConfiguration;
    /**
      Configuration of the screen for cropping the scanned pages.
      */
    cropping: CroppingScreenConfiguration;
    /**
      Configuration of the screen for reordering the scanned pages.
      */
    reorderPages: ReorderPagesScreenConfiguration;
    /** @param source {@displayType `DeepPartial<DocumentScannerScreens>`} */
    constructor(source?: DeepPartial<DocumentScannerScreens>);
}
//# sourceMappingURL=DocumentScannerScreens.d.ts.map