import { ButtonConfiguration, StyledText } from '../../ui_v2/common/Common';
import { UserGuidanceConfiguration } from '../../ui_v2/common/UserGuidanceConfiguration';
import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the screen for reordering the scanned pages.
*/
export declare class ReorderPagesScreenConfiguration extends PartiallyConstructible {
    /**
      Configuration of the 'cancel' button, located in the top bar.
      */
    topBarBackButton: ButtonConfiguration;
    /**
      Configuration of the title, located in the top bar.
      */
    topBarTitle: StyledText;
    /**
      Configuration of the 'confirm' button, located in the top bar.
      */
    topBarConfirmButton: ButtonConfiguration;
    /**
      The background color of the reorder pages screen.
      
      Default is "?sbColorOutline"
      */
    backgroundColor: string;
    /**
      Configuration of the static user guidance, located just below the top bar.
      */
    guidance: UserGuidanceConfiguration;
    /**
      Configuration of the title below each page object.
      */
    pageTextStyle: StyledText;
    /** @param source {@displayType `DeepPartial<ReorderPagesScreenConfiguration>`} */
    constructor(source?: DeepPartial<ReorderPagesScreenConfiguration>);
}
//# sourceMappingURL=ReorderPagesScreenConfiguration.d.ts.map