import { ResultWrapper } from '../base';
import { DocumentData } from '../document_scanner';
import { BarcodeScannerScreenConfiguration } from './barcode/BarcodeScannerScreenConfiguration';
import { BarcodeScannerUiResult } from './barcode/BarcodeScannerUiResult';
import { CreditCardScannerScreenConfiguration } from './creditcard/CreditCardScannerScreenConfiguration';
import { CreditCardScannerUiResult } from './creditcard/CreditCardScannerUIResult';
import { CroppingConfiguration } from './document/CroppingConfiguration';
import { DocumentScanningFlow } from './document/DocumentScanningFlow';
import { MrzScannerScreenConfiguration } from './mrz/MRZScannerScreenConfiguration';
import { MrzScannerUiResult } from './mrz/MRZScannerUIResult';
import { TextPatternScannerScreenConfiguration } from './textpattern/TextPatternScannerScreenConfiguration';
import { TextPatternScannerUiResult } from './textpattern/TextPatternScannerUIResult';
/**
 * Opens the Ready-To-Use UI screen for scanning Barcodes and QR-Codes with the desired configuration.
 */
export declare function startBarcodeScanner(config: BarcodeScannerScreenConfiguration): Promise<ResultWrapper<BarcodeScannerUiResult>>;
/**
 * Opens the Ready-To-Use UI Document Scanner screen with the desired configuration.
 */
export declare function startDocumentScanner(config: DocumentScanningFlow): Promise<ResultWrapper<DocumentData>>;
/**
 * Opens the Ready-To-Use UI Cropping screen with the desired configuration.
 */
export declare function startCroppingScreen(config: CroppingConfiguration): Promise<ResultWrapper<DocumentData>>;
/**
 * Opens the Ready-To-Use UI MRZ Scanner screen with the desired configuration.
 */
export declare function startMRZScanner(config: MrzScannerScreenConfiguration): Promise<ResultWrapper<MrzScannerUiResult>>;
/**
 * Opens the Ready-To-Use UI Text Pattern scanner with the desired configuration.
 */
export declare function startTextPatternScanner(config: TextPatternScannerScreenConfiguration): Promise<ResultWrapper<TextPatternScannerUiResult>>;
/**
 * Opens the Ready-To-Use UI Credit Card scanner with the desired configuration.
 */
export declare function startCreditCardScanner(config: CreditCardScannerScreenConfiguration): Promise<ResultWrapper<CreditCardScannerUiResult>>;
export * from './barcode/ArTrackingOverlayConfiguration';
export * from './barcode/BarcodeInfoMapping';
export * from './barcode/BarcodeItemMapper';
export * from './barcode/BarcodeScannerConfiguration';
export * from './barcode/BarcodeScannerScreenConfiguration';
export * from './barcode/BarcodeScannerUiResult';
export * from './barcode/BarcodeTextLocalization';
export * from './barcode/BarcodeUseCase';
export * from './barcode/FindAndPickScanningModeUseCase';
export * from './barcode/MultipleScanningModeUseCase';
export * from './barcode/SingleScanningModeUseCase';
export * from './common/ActionBarConfiguration';
export * from './common/CameraConfiguration';
export * from './common/CameraPermission';
export * from './common/Common';
export * from './common/NavigationBarConfiguration';
export * from './common/ScanCompletionOverlay';
export * from './common/ScanbotAlertDialog';
export * from './common/TopBarConfiguration';
export * from './common/UserGuidanceConfiguration';
export * from './common/ViewFinderConfiguration';
export * from './creditcard/CreditCardScannerIntroScreenConfiguration';
export * from './creditcard/CreditCardScannerScreenConfiguration';
export * from './creditcard/CreditCardScannerScreenTextLocalization';
export * from './creditcard/CreditCardScannerUIResult';
export * from './creditcard/CreditCardScannerUserGuidance';
export * from './creditcard/CreditCardScanningProgressConfiguration';
export * from './document/AcknowledgementScreenConfiguration';
export * from './document/CameraScreenConfiguration';
export * from './document/CroppingConfiguration';
export * from './document/CroppingResult';
export * from './document/CroppingScreenConfiguration';
export * from './document/CroppingTextLocalization';
export * from './document/DocumentScannerCameraConfiguration';
export * from './document/DocumentScannerGuidanceVisibility';
export * from './document/DocumentScannerOutputSettings';
export * from './document/DocumentScannerScreens';
export * from './document/DocumentScannerTextLocalization';
export * from './document/DocumentScannerUserGuidance';
export * from './document/DocumentScanningFlow';
export * from './document/IntroductionScreenConfiguration';
export * from './document/ReorderPagesScreenConfiguration';
export * from './document/ReviewScreenConfiguration';
export * from './mrz/MRZFinderLayoutPreset';
export * from './mrz/MRZScannerIntroScreenConfiguration';
export * from './mrz/MRZScannerScreenConfiguration';
export * from './mrz/MRZScannerScreenTextLocalization';
export * from './mrz/MRZScannerUIResult';
export * from './textpattern/TextPatternScannerIntroScreenConfiguration';
export * from './textpattern/TextPatternScannerScreenConfiguration';
export * from './textpattern/TextPatternScannerScreenTextLocalization';
export * from './textpattern/TextPatternScannerUIResult';
//# sourceMappingURL=index.d.ts.map