import { GenericDocument } from '../../documents/GenericDocument';
import { ToJsonConfiguration } from '../../utils/json/JsonSerializationTypes';
import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the MRZ RTU UI result.
*/
export declare class MrzScannerUiResult extends PartiallyConstructible {
    /**
      Raw string value of MRZ.
      */
    readonly rawMRZ: string;
    /**
      Generic document containing MRZ data.
      */
    readonly mrzDocument: GenericDocument | null;
    /** @param source {@displayType `DeepPartial<MrzScannerUiResult>`} */
    constructor(source?: DeepPartial<MrzScannerUiResult>);
    serialize(config?: ToJsonConfiguration): Promise<DeepPartial<MrzScannerUiResult>>;
    private _released;
    release(): void;
    encodeImages(): Promise<void>;
}
//# sourceMappingURL=MRZScannerUIResult.d.ts.map