import { SymbolBox, WordBox } from '../../text_pattern_scanner/TextPatternScannerTypes';
import { ToJsonConfiguration } from '../../utils/json/JsonSerializationTypes';
import { DeepPartial, PartiallyConstructible } from '../../utils/utils';
/**
Configuration of the generic text scanner RTU UI result.
*/
export declare class TextPatternScannerUiResult extends PartiallyConstructible {
    /**
      Raw recognized string.
      */
    readonly rawText: string;
    /**
      Boxes for each recognized word.
      */
    readonly wordBoxes: WordBox[];
    /**
      Boxes for each recognized symbol.
      */
    readonly symbolBoxes: SymbolBox[];
    /**
      Confidence of the recognition.
      
      Default is 0.0
      */
    readonly confidence: number;
    /** @param source {@displayType `DeepPartial<TextPatternScannerUiResult>`} */
    constructor(source?: DeepPartial<TextPatternScannerUiResult>);
    serialize(config?: ToJsonConfiguration): DeepPartial<TextPatternScannerUiResult>;
}
//# sourceMappingURL=TextPatternScannerUIResult.d.ts.map